#include <stdio.h>
#include "mex.h"
#include <math.h>

#undef		MIN
#undef		MAX
#define		MIN(a, b)       ((a) < (b) ? (a) : (b))	
#define		MAX(a, b)       ((a) > (b) ? (a) : (b))	

inline int myfloor(double d) {
    int f = d;
    return f;
}

void main_stuff(double *gpad, double *w, int Mp, int win, double *jjset, int jjsize, double *kernel, double h, int SearchWin)
{
    int M;
    int i;
    int ic;
    int ir;
    int k, jj;
    int winLength = 2*win+1;
    int winSize   = 2*win+1;
    double sse, wsum;
    double block_ref, block_cur, block_err, alpha;
    int ic_min, ic_max;

    M = Mp - 2*win;

    for (k=0; k<jjsize; k++)
    {
        
        jj = jjset[k]-1;
        
        ir = jj;
        
        wsum = 0.0;
        
        ic_min = MAX(0,ir-SearchWin);
        ic_max = MIN(M,ir+SearchWin);        

            for (i=0; i<M; i++)
            {
            w[i] = 0;
            }

            for (ic=ic_min; ic<ic_max; ic++)
            {
            sse = 0.0;
            if (win>0)
            {
                for (i=0; i<winLength; i++)
                {
                block_ref = gpad[ir+i];
                block_cur = gpad[ic+i];
                block_err = block_ref-block_cur;
                alpha     = kernel[i];
                sse       = sse + block_err*block_err*alpha;
                }
            }
            else
            {
                block_ref = gpad[ir];
                block_cur = gpad[ic];
                block_err = block_ref-block_cur;
                sse       = sse + block_err*block_err;
            }
            
            w[ic] = exp(-sse/(h*h));
            }
    }
    
}



/////////////////////////
// Interface Function
/////////////////////////
void mexFunction(int nlhs, mxArray *plhs[],
        int nrhs, const mxArray *prhs[])
{
    double *w, *gpad, *kernel;
    double *jjset;
    int jjsize, win, SearchWin;
    int Mp, M;
    double h;
    
    /////////////////////
    // Inputs
    /////////////////////
    // Input 1
    gpad = mxGetPr(prhs[0]);
    Mp   = mxGetM(prhs[0]);
    
    // Input 2
    jjset  = mxGetPr(prhs[1]);
    jjsize = mxGetM(prhs[1]);
    
    // Input 3
    win  = mxGetScalar(prhs[2]);
    
    // Input 3
    kernel = mxGetPr(prhs[3]);
    
    // Input 4
    h = mxGetScalar(prhs[4]);
    
    // Input 4
    SearchWin = mxGetScalar(prhs[5]);
    
    // Calculate M
    M = Mp - 2*win;
    
    ////////////////////
    // Outputs
    ////////////////////
    plhs[0] = mxCreateDoubleMatrix(M, 1, mxREAL);
    w       = mxGetPr(plhs[0]);
    
    main_stuff(gpad,w,Mp,win,jjset,jjsize,kernel,h,SearchWin);
}