clear all
close all
clc


% Get noisy data
f = (im2double(imread('images/eyes_closeup_smaller.png')));

noisestddev = 0.2;
randn('seed', 0);
g = f + noisestddev * randn(size(f));

% f = repmat(f,[1 1 3]);
% g = repmat(g,[1 1 3]);

% Compute non-local-means patch space using 7x7 color patches reduced to 25 dimensions.
patch_radius       = 3; % patch size is 2*patch_radius + 1;
num_pca_dimensions = 25;
nlmeans_space      = compute_non_local_means_basis(g, patch_radius, num_pca_dimensions);

% Filtering parameters
sigma_s = 10;
sigma_r = 0.35;
pca_iterations = 2;

% Compute tree height using Eq. (12)
tree_height = 2 + compute_manifold_tree_height(sigma_s, sigma_r);

% tilde_g is the output of our filter with outliers suppressed.
[fhat1,fhat2] = adaptive_manifold_filter(g, sigma_s, sigma_r, tree_height, nlmeans_space, pca_iterations);

psnr1 = -10*log10(norm(fhat1(:)-f(:))^2/numel(f))
psnr2 = -10*log10(norm(fhat2(:)-f(:))^2/numel(f))


