clear all
close all
clc

% This routine plots Fig.2
% Purpose: show snapshots of the denoised results
%
% Stanley Chan @ Harvard
% May 23, 2013
% Aug 16, 2013

addpath(genpath('../utilities/'));

% Coordinates for cropped view
xc1 = 304;
yc1 = 486;

xc2 = 536;
yc2 = 749;

% 1. PSNR for noisy image
f  = im2double(imread('../data/Fig3_data/building_16.png'));
g  = f + random('normal',0, 15/255, size(f)); % Create Noisy Data
psnr_noisy = psnr(f,g);
g_half = imresize(g,0.5);
g_c1   = g(yc1+[-89:88], xc1+[-89:88]);
g_c2   = g(yc2+[-89:88], xc2+[-89:88]);
imshow(g_half); export_fig chan02a1.eps -transparent -RGB;
imshow([g_c1 g_c2]);   export_fig chan02a2.eps -transparent -RGB;



% 2. PSNR for denoised image, at xi = 0.1
f1 = im2double(imread('../data/Fig3_data/result_xi_0p1.png'));
psnr_01 = psnr(f,f1);
f1_half = imresize(f1,0.5);
f1_c1   = f1(yc1+[-89:88], xc1+[-89:88]);
f1_c2   = f1(yc2+[-89:88], xc2+[-89:88]);
imshow(f1_half); export_fig chan02c1.eps -transparent -RGB;
imshow([f1_c1 f1_c2]);   export_fig chan02c2.eps -transparent -RGB;



% 3. PSNR for denoised image, at xi = 0.05
f2 = im2double(imread('../data/Fig3_data/result_xi_0p05.png'));
psnr_005= psnr(f,f2);
f2_half = imresize(f2,0.5);
f2_c1   = f2(yc1+[-89:88], xc1+[-89:88]);
f2_c2   = f2(yc2+[-89:88], xc2+[-89:88]);
imshow(f2_half); export_fig chan02b1.eps -transparent -RGB;
imshow([f2_c1 f2_c2]);   export_fig chan02b2.eps -transparent -RGB;





% imwrite(g, 'harvard_noisy.png'); % write Image
% imwrite(g(yc1+[-89:88], xc1+[-89:88]), 'harvard_noisy_crop1.png');
% imwrite(g(yc2+[-89:88], xc2+[-89:88]), 'harvard_noisy_crop2.png');

% imwrite(frandom(:,:,1), 'harvard_ours_01.png');
% imwrite(frandom(yc1+[-89:88], xc1+[-89:88], 1), 'harvard_ours_01_crop1.png');
% imwrite(frandom(yc2+[-89:88], xc2+[-89:88], 1), 'harvard_ours_01_crop2.png')

% imwrite(frandom, 'harvard_ours_005.png');
% imwrite(frandom(yc1+[-89:88], xc1+[-89:88]), 'harvard_ours_005_crop1.png');
% imwrite(frandom(yc2+[-89:88], xc2+[-89:88]), 'harvard_ours_005_crop2.png');
