clear all
close all
clc

% This routine plots Fig.3
% Purpose: show PSNR curve as a function of xi
% for Harvard image, at infinite search window
%
% Stanley Chan @ Harvard
% May 23, 2013

figure;
fontsize = 12;
set(0,'defaultaxesfontsize',fontsize);
set(0,'defaulttextfontsize',fontsize);

fontname = 'Times New Roman';
set(0,'defaultaxesfontname',fontname);
set(0,'defaulttextfontname',fontname);

fontweight = 'normal';
set(0,'defaultaxesfontweight',fontweight);
set(0,'defaulttextfontweight',fontweight);

load('../data/Fig3_data/psnr_data');
semilogx(c_set/(M*N),PSNR,'k-o','LineWidth',2); hold on;
semilogx(c_set/(M*N),PSNR_full*ones(length(PSNR),1), 'r-.', 'LineWidth',2, 'MarkerSize',10);

% load('../data/Fig3_data/psnr_data_bm3d');
% semilogx(c_set/(M*N),PSNR_bm3d*ones(length(PSNR),1), 'b-', 'LineWidth',2, 'MarkerSize',10);
% 
% load('../data/Fig3_data/psnr_data_kd');
% semilogx(c_set/(M*N),PSNR_kd*ones(length(PSNR),1), 'b-.', 'LineWidth',2, 'MarkerSize',10);
% 
% load('../data/Fig3_data/psnr_data_am');
% semilogx(c_set/(M*N),PSNR_am*ones(length(PSNR),1), 'b:', 'LineWidth',2, 'MarkerSize',10);

grid on;
axis([0 1 24 30.5]);

xlabel('$\xi$','interpreter','latex','fontsize',12);
ylabel('PSNR (dB)','fontsize',12);
legend('Monte Carlo NLM', 'Classical NLM', 'Location','SE');
export_fig chan03.eps -transparent -RGB;