clear all
close all
clc

% This routine plots Fig.5(a)
% Purpose: illustrates the noisy signal q_j
%
% Stanley Chan @ Harvard
% May 23, 2013
% Aug 16, 2013

n = 10000;
x = linspace(0,1,round(n/4));
f = [0.25*(sin(5.5*x)+1.5) 0.5*ones(1,round(n/4)) 0.25*(cos(2.4*x)+1) 0.25*ones(1,round(n/4))];
f = f';

g = f + random('normal',0,5/255,size(f));
g(g>1) = 1;
g(g<0) = 0;

figure(1);
plot(g,'k','LineWidth',2);
xlabel('$j$','Interpreter','latex','fontsize',12);
ylabel('$x_j$','Interpreter','latex','fontsize',12);
title('signal $\{x_j\}_{j=1}^n$','Interpreter','latex','fontsize',14);
grid on;
rectangle('Position',[4750,0.49,500,0.02],'EdgeColor',[1 0.5 0],'LineWidth',2);

export_fig chan05a.eps -transparent -RGB;