clear all
close all
clc

% This routine plots Fig.6(a)
% Purpose: overlap a Gaussian weight on top of cameraman
%
% Stanley Chan @ Harvard
% May 23, 2013

f = im2double(imread('cameraman.tif'));
g = f + random('normal',0,5/255,size(f));
g(g>1) = 1;
g(g<0) = 0;

Fig = figure(1);
H = fspecial('gaussian',[501,501],50);
H = H(250+[-73:256-74],250+[-73:256-74]);
H = H/max(H(:));
imshow(f+H,[]); hold on;
% rectangle('Position',[75-49,75-49,100,100],'EdgeColor','b');
scatter([75],[75],'o','MarkerFaceColor',[0 0 1],'MarkerEdgeColor',[0 0.2 1]);
Fig_prop = get(gcf);
boundbox = Fig_prop.PaperPosition;
width    = boundbox(3);
height   = boundbox(4);
set(gcf, 'PaperPosition', [0, 0, width, height]);
set(gcf, 'PaperSize', [width height]);
export_fig chan06a.eps -transparent -RGB;
% saveas(Fig, 'app_samp_f.eps','epsc');