clear all
close all
clc

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Merge and Display Results
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

max_trial = 20;
psnr_mean = zeros(20,max_trial);
psnr_unif = zeros(20,max_trial);
psnr_anat = zeros(20,max_trial);

folder_out = 'C:/Users/Stanley Chan/Desktop/Result_MeanSampling/';

for tidx = 1:max_trial
folder = sprintf('%strial_%02d/', folder_out, tidx);

load('../../data/Fig8_data/data.mat');

win    = 2;
z_full = reshape(xL(5+[-win:win],5+[-win:win],:),(2*win+1)^2,2000);
z      = z_full(((2*win+1)^2+1)/2,:)';
zanat  = ex1(2*win+1-2,:);

znum_mean = zeros(2000,20);
zden_mean = zeros(2000,20);

znum_unif = zeros(2000,20);
zden_unif = zeros(2000,20);

runtime_mean = zeros(20,1);
runtime_unif = zeros(20,1);

for fid_ptr=1:15
    fprintf('fid = %3g \n', fid_ptr);
    fname = sprintf('%sbatch_%03d.mat',folder,fid_ptr);
    load(fname);
    
    znum_mean = znum_mean + znum1;
    znum_unif = znum_unif + znum2;
    zden_mean = zden_mean + zden1;
    zden_unif = zden_unif + zden2;
    
    runtime_mean = runtime_mean + runtime1;
    runtime_unif = runtime_unif + runtime2;
end

zhat1 = znum_mean./zden_mean;
zhat2 = znum_unif./zden_unif;

for sidx = 1:length(SamplingRatio_list)
    psnr_mean(sidx,tidx) = -10*log10( norm(z(:) - zhat1(:,sidx))^2/2000 );
    psnr_unif(sidx,tidx) = -10*log10( norm(z(:) - zhat2(:,sidx))^2/2000 );
    psnr_anat(sidx,tidx) = -10*log10( norm(z(:) - zanat(:))^2/2000 );
end
end
save('../../data/Fig8_data/psnr_result1.mat', 'psnr_mean','psnr_unif','psnr_anat','SamplingRatio_list');

% load('../../data/Fig8_data/psnr_result.mat');
figure(1);
semilogx(SamplingRatio_list, mean(psnr_mean,2), 'b-o', 'LineWidth', 2);
hold on;
semilogx(SamplingRatio_list, mean(psnr_unif,2), 'r-x', 'LineWidth', 2);
semilogx(SamplingRatio_list, mean(psnr_anat,2), 'k:', 'LineWidth', 4);
grid on;
axis([1e-6 1e-2 29 33]);
legend('Optimal Sampling','Uniform Sampling','Full Solution','Location','SE');
xlabel('Sampling Ratio','Interpreter','latex','fontsize',12);
ylabel('PSNR (dB)','Interpreter','latex','fontsize',12);

