function tau = compute_tau(ymean, xmeansort, SamplingRatio, h, m, n)
maxQlevels = 32;
StepSize   = 100;

% build histogram of xmean
xhist_boundary    = 1/maxQlevels + linspace(0,1,maxQlevels+1);
xhist_center      = xhist_boundary-(1/(2*maxQlevels));
[xhist_count, ~]  = hist(xmeansort(1:StepSize:n), xhist_center);

% compute tau
tau = zeros(m,1);
for i=1:m
    w = exp(-abs(ymean(i)-xhist_center(:)).^2/(2*h*h));
    tau(i) = SamplingRatio/( StepSize*sum(xhist_count(:).*w(:))/n );
end