function out = compute_xstat( x_full, win, Qlevels )

% Compute xmean
    xmean  = imfilter(x_full, ones(2*win+1,2*win+1)/(2*win+1)^2, 'symmetric');
    
    % sort xmean
    [xmeansort, sidx] = sort(xmean(:));

    % build histogram of xmean
    xhist_boundary      = 1/Qlevels + linspace(0,1,Qlevels+1);
    xhist_boundary      = [0 xhist_boundary(1:Qlevels)];
    xhist_count         = zeros(1,Qlevels);
    xhist_idx           = cell(1,Qlevels);
    for j=1:Qlevels
        xhist_idx{j}   = sidx(((xmeansort>=xhist_boundary(j))&(xmeansort<xhist_boundary(j+1))));
        xhist_count(j) = numel(xhist_idx{j});
    end
    xhist_boundary(1) = [];

    % pre-permute indices
    xhist_idx_randperm = zeros(max(xhist_count),Qlevels);
    for j=1:Qlevels
        xhist_idx_randperm(1:xhist_count(j),j) = xhist_idx{j}(randperm(xhist_count(j)));
    end

out.xmean               = xmean;
out.xmeansort           = xmeansort;
out.sidx                = sidx;
out.xhist_boundary      = xhist_boundary;
out.xhist_count         = xhist_count;
out.xhist_idx_randperm  = xhist_idx_randperm;