clear all
close all
clc

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Main Experiment for External Denoising
%
% Stanley Chan
% Copyright 2013 Harvard University
% Last Update: Nov 20, 2013
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

addpath(genpath('../code/'));
addpath(genpath('../utilities/'));

% Switch ON MATLAB pool for parallel computing
mSize = matlabpool('size');
if mSize==0
    matlabpool open;
end

% save folder
sfolder = '../../data/Fig8_data/result/';
trialid = 1; % trialid can be sweeped from 1 to max_trials, where max_trials = 12 in the paper.

% Main routine
for batchid = 1:15 % 15 batches for 15,000 images
    fprintf('batchid = %3g \n', batchid);
    
    trial_folder = sprintf('%strial_%02d/',sfolder,trialid);
    if ~exist(trial_folder,'file')
        mkdir(trial_folder);
    end
    
    sname = sprintf('%sbatch_%03d',trial_folder,batchid);

    [psnr1,psnr2,SamplingRatio_list,runtime1,runtime2,zden1,zden2,znum1,znum2,MeanActualSamplingRatio1,MeanActualSamplingRatio2] = core_outer(batchid);
    
    save(sname,'psnr1','psnr2','SamplingRatio_list','runtime1','runtime2','zden1','zden2','znum1','znum2','MeanActualSamplingRatio1','MeanActualSamplingRatio2');
end

matlabpool close;