clear all
close all
clc

%%%%%%%%%%%%%%%%%%%%%
% Plot SNR vs sampling ratio for external denoising
%
%%%%%%%%%%%%%%%%%%%%%

load('../data/Fig8_data/psnr_result.mat');
semilogx(SamplingRatio_list, mean(psnr_mean,2), 'b-o', 'LineWidth', 2);
hold on;
semilogx(SamplingRatio_list, mean(psnr_unif,2), 'r-x', 'LineWidth', 2);
semilogx(SamplingRatio_list, mean(psnr_anat,2), 'k:', 'LineWidth', 4);
grid on;
axis([1e-6 1e-2 29 33]);
legend('Optimal Sampling','Uniform Sampling','Full Solution','Location','SE');
xlabel('Sampling Ratio','Interpreter','latex','fontsize',12);
ylabel('PSNR (dB)','Interpreter','latex','fontsize',12);
export_fig chan08.eps -transparent -RGB;