clear all
close all
clc

% This routine displays the values of Tables II
% 
% Output Format: LaTeX
% 
% Stanley Chan @ Harvard
% May 23, 2013

sigma_set = 10:10:50;
fprintf('sigma \t\t 0.05 \t\t\t\t\t\t 0.1 \t\t\t\t\t\t 0.2 \t\t\t\t\t\t 0.5 \t\t\t\t\t\t 1 \t\t\t\t GKD \t\t\t AM \t\t\t BM3D  \n');
fprintf('--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------  \n');
for i=1:5
    sigma = sigma_set(i);
    fname = sprintf('../data/Table1_data/change_both_win%02d_sigma%02d.mat',10,sigma);
    load(fname);
    
    y1 = sum(sum(psnr_mcnlm(:,:,1,i,:),2),5)./numel(psnr_mcnlm(1,:,1,i,:));
    y2 = sum(sum(psnr_mcnlm(:,:,2,i,:),2),5)./numel(psnr_mcnlm(1,:,2,i,:));
    y3 = sum(sum(psnr_mcnlm(:,:,3,i,:),2),5)./numel(psnr_mcnlm(1,:,3,i,:));
    y4 = sum(sum(psnr_mcnlm(:,:,4,i,:),2),5)./numel(psnr_mcnlm(1,:,4,i,:));
    zfull = psnr_full(:,i,:);
    zgkd  = psnr_kd(:,i,:);
    zam   = psnr_am(:,i,:);
    zbm3d = psnr_bm3d(:,i,:);
    
    str1 = ' \t & \t %3.2f $\\pm$ %3.2e';
    str3 = ' \t & \t %3.2f ';
    str2 = ['%3g ', str1, str1, str1, str1, str3, str3, str3, str3, '\n'];
    fprintf(str2,sigma,mean(y1),std(y1),mean(y2),std(y2),mean(y3),std(y3),mean(y4),std(y4),mean(zfull(:)),mean(zgkd(:)), mean(zam(:)), mean(zbm3d(:)));
end