%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This routine generates result for Supplementary
% material Figure 1
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all
close all
clc

addpath(genpath('../offshelf_packages/'));
addpath(genpath('../code/'));
addpath(genpath('../utilities/'));

currentFolder = pwd;

% Outer Parameters
SearchWin = 10;
win       = 2;
sigma     = 20;

% Parameters
hs = SearchWin/3;
hr = sigma/255;

% Load data
f      = im2double(imread('../data/standard_images/house.png'));
g      = f + random('normal',0, sigma/255, size(f));
g(g>1) = 1;
g(g<0) = 0;

% Denoise
xi = 0.2;

t0 = tic;
fhat1 = mcnlm(g,hr,hs,win,SearchWin,xi,'oracle');
t1 = toc(t0);

t0 = tic;
fhat2 = mcnlm(g,hr,hs,win,SearchWin,xi,'uniform');
t2 = toc(t0);

t0 = tic;
fhat3 = mcnlm(g,hr,hs,win,SearchWin,xi,'spatial');
t3 = toc(t0);

psnr1 = psnr(fhat1,f);
psnr2 = psnr(fhat2,f);
psnr3 = psnr(fhat3,f);

% display
imshow(fhat1); export_fig supp_house_oracle.eps -transparent
imshow(fhat2); export_fig supp_house_uniform.eps -transparent
imshow(fhat3); export_fig supp_house_spatial.eps -transparent

