function Gproj = pca_projection(g,win,numpca)
[M N] = size(g);
gpad = padarray(g,[win win],'symmetric');

G = zeros(M,N,(2*win+1)^2);
for i=1:2*win+1
    for j=1:2*win+1
        k = sub2ind([2*win+1 2*win+1], i, j);
        G(:,:,k) = gpad(i:i+M-1, j:j+N-1);
    end
end
G = reshape(shiftdim(G,2),(2*win+1)^2, M*N);

[~, Gproj, ~, ~] = pca(G, numpca);

%%% ------ less efficient ------- %%%
% G = zeros((2*win+1)^2, M*N);
% for i=1:M
%     for j=1:N
%         k = sub2ind([M N],i,j);
%         block = gpad(i:i+2*win, j:j+2*win);
%         G(:,k) = block(:);
%     end
% end
%%% ----------------------------- %%%